package cn.iocoder.yudao.module.iot.service.alert;

import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import cn.iocoder.yudao.module.iot.controller.admin.alert.vo.*;
import cn.iocoder.yudao.module.iot.dal.dataobject.alert.AlertDO;
import cn.iocoder.yudao.module.iot.dal.dataobject.alertrecord.AlertRecordDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;

import cn.iocoder.yudao.module.iot.dal.mysql.alert.AlertMapper;
import cn.iocoder.yudao.module.iot.dal.mysql.alertrecord.AlertRecordMapper;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.iot.enums.ErrorCodeConstants.*;

/**
 * 告警配置 Service 实现类
 *
 * @author 内蒙必硕
 */
@Service
@Validated
public class AlertServiceImpl implements AlertService {

    @Resource
    private AlertMapper alertMapper;
    @Resource
    private AlertRecordMapper alertRecordMapper;

    @Override
    public Long createAlert(AlertSaveReqVO createReqVO) {
        // 插入
        AlertDO alert = BeanUtils.toBean(createReqVO, AlertDO.class);
        alertMapper.insert(alert);
        // 返回
        return alert.getId();
    }

    @Override
    public void updateAlert(AlertSaveReqVO updateReqVO) {
        // 校验存在
        validateAlertExists(updateReqVO.getId());
        // 更新
        AlertDO updateObj = BeanUtils.toBean(updateReqVO, AlertDO.class);
        alertMapper.updateById(updateObj);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void deleteAlert(Long id) {
        // 校验存在
        validateAlertExists(id);
        // 删除
        alertMapper.deleteById(id);

        // 删除子表
        deleteAlertRecordByAlertId(id);
    }

    private void validateAlertExists(Long id) {
        if (alertMapper.selectById(id) == null) {
            throw exception(ALERT_NOT_EXISTS);
        }
    }

    @Override
    public AlertDO getAlert(Long id) {
        return alertMapper.selectById(id);
    }

    @Override
    public PageResult<AlertDO> getAlertPage(AlertPageReqVO pageReqVO) {
        return alertMapper.selectPage(pageReqVO);
    }

    // ==================== 子表（告警记录） ====================

    @Override
    public PageResult<AlertRecordDO> getAlertRecordPage(PageParam pageReqVO, Long alertId) {
        return alertRecordMapper.selectPage(pageReqVO, alertId);
    }

    @Override
    public Long createAlertRecord(AlertRecordDO alertRecord) {
        alertRecordMapper.insert(alertRecord);
        return alertRecord.getId();
    }

    @Override
    public void updateAlertRecord(AlertRecordDO alertRecord) {
        // 校验存在
        validateAlertRecordExists(alertRecord.getId());
        // 更新
        alertRecordMapper.updateById(alertRecord);
    }

    @Override
    public void deleteAlertRecord(Long id) {
        // 校验存在
        validateAlertRecordExists(id);
        // 删除
        alertRecordMapper.deleteById(id);
    }

    @Override
    public AlertRecordDO getAlertRecord(Long id) {
        return alertRecordMapper.selectById(id);
    }

    private void validateAlertRecordExists(Long id) {
        if (alertRecordMapper.selectById(id) == null) {
            throw exception(ALERT_RECORD_NOT_EXISTS);
        }
    }

    private void deleteAlertRecordByAlertId(Long alertId) {
        alertRecordMapper.deleteByAlertId(alertId);
    }

}